<template>
    <div v-if="hasProducts" class="container cart-product">
        <h3>Product(s) added to shopping cart</h3>
        <table class="table table-sm">
            <caption></caption>
            <thead class="table-dark">
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Product</th>
                    <th scope="col">Quantity</th>
                    <th scope="col">Price</th>
                    <th scope="col">Subtotal</th>
                    <th scope="col" class="text-end pe-3">Remove</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="(product, index) in products" :key="product.id">
                    <th scope="row">{{ index + 1 }}</th>
                    <td>{{ product.name }}</td>
                    <td>{{ product.amount }}</td>
                    <td>{{ product.price }}</td>
                    <td>{{ product.price * product.amount }}</td>
                    <td class="text-end pe-4">
                        <button
                            class="btn btn-danger btn-sm"
                            type="button"
                            @click="removeProduct(product)"
                        >
                            <em class="bi bi-trash-fill" />
                        </button>
                    </td>
                </tr>
            </tbody>
            <tfoot>
                <tr>
                    <th scope="col" colspan="4">Total</th>
                    <th scope="col">{{ total }}</th>
                    <th scope="col"></th>
                </tr>
            </tfoot>
        </table>
        <div class="d-grid gap-2 d-md-flex justify-content-md-end">
            <router-link class="btn btn-success btn-lg" to="/products">
                <em class="bi bi-bag" /> Keep shopping
            </router-link>
            <router-link class="btn btn-primary btn-lg" to="/checkout">
                <em class="bi bi-credit-card" /> Buy now
            </router-link>
        </div>
    </div>
    <div v-else class="container cart-product text-center">
        <h4>Your cart is empty</h4>
    </div>
</template>
<script>
import {useStore} from 'vuex';
import {computed} from 'vue';
export default {
    props: {
        products: {
            type: Array,
            default: () => [],
            required: true,
        },
        total: {
            type: Number,
            required: true,
            default: 0,
        },
    },
    emits: ['remove-products'],
    setup(_, {emit}) {
        const {getters} = useStore();
        const removeProduct = (product) => {
            emit('remove-products', product);
        };
        return {
            removeProduct,
            hasProducts: computed(() => getters['product/totalProducts'] > 0),
        };
    },
};
</script>
<style lang="scss" scoped>
.cart-product {
    padding: 20px;
}
</style>
